VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   1095
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   3525
   LinkTopic       =   "Form1"
   ScaleHeight     =   1095
   ScaleWidth      =   3525
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   855
      Left            =   150
      TabIndex        =   0
      Top             =   120
      Width           =   3255
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' IOperationsProgressDialog und IFileOperationProgressSink sind Optional!!!
Private cIOperationsProgressDialog As clsIOperationsProgressDialog
Private WithEvents cIFileOperationProgressSink As clsIFileOperationProgressSink
Attribute cIFileOperationProgressSink.VB_VarHelpID = -1

Private Sub Command1_Click()
        
    Dim sFileOrFolderFrom As String
    Dim aFileOrFolderFrom() As String
    Dim sFolderTo As String
    
    ' Optional!!!
    Set cIOperationsProgressDialog = New clsIOperationsProgressDialog
    Set cIFileOperationProgressSink = New clsIFileOperationProgressSink
    
    sFileOrFolderFrom = "C:\FolderFrom"
    sFolderTo = "C:\FolderTo"
    
    ' sFileOrFolderFrom = "Drive:\Folder0" ' kompletten Ordner
    ' or
    ' sFileOrFolderFrom = "Drive:\File.ext" ' eine Datei
    ' or
    ' sFileOrFolderFrom = "Drive:\Folder1\Folder2"
    ' or
    ' sFileOrFolderFrom = "Drive:\Folder3\File.ext"
    ' usw.
    '
    ' sFolderTo = "Drive:\Folder" ' in welchem Ordner
    
    ' Bsp mit beiden optionalen Interfaces.
    ' Wenn das Interface IOperationsProgressDialog verwendet werden soll,
    ' dann muss mindestens FOF_SILENT angegeben werden damit der Standard
    ' ProgressDialog nicht angezeigt wird.
    '
    'Debug.Print CopyItem(sFileOrFolderFrom, sFolderTo, FOF_SILENT, _
    '   Me.hwnd, cIFileOperationProgressSink, cIOperationsProgressDialog, _
    '   OPPROGDLG_DEFAULT)
    
    
    ' Bsp nur mit dem optionalen Interface IFileOperationProgressSink
    ' wenn FOF_SILENT angegeben wurde, dann kann man die Events nutzen
    ' um einen eigenen ProgressDialog damit zu steuern.
    '
    If CopyItem(sFileOrFolderFrom, sFolderTo, FOF_ALLOWUNDO, Me.hwnd, _
        cIFileOperationProgressSink) = True Then
        
        Debug.Print "Kopieren war erfolgreich."
        
    Else
    
        Debug.Print "Kopieren wurde abgebrochen."
    
    End If
    
    ' Bsp ohne optionale Interfaces
    '
    'Debug.Print CopyItem(sFileOrFolderFrom, sFolderTo, FOF_ALLOWUNDO, Me.hwnd)


    ' Bsp fr mehrere Ordner oder Dateien
    '
    ' ReDim aFileOrFolderFrom(3)
    ' aFileOrFolderFrom(0) = "Drive:\Folder0"
    ' aFileOrFolderFrom(1) = "Drive:\Folder1\Folder2"
    ' aFileOrFolderFrom(2) = "Drive:\File.ext"
    ' aFileOrFolderFrom(3) = "Drive:\Folder3\File.ext"
    ' sFolderTo = "Drive:\Folder"
    '
    'Debug.Print CopyItems(aFileOrFolderFrom, sFolderTo, _
    '    FOF_SILENT, Me.hwnd, cIFileOperationProgressSink, _
    '    cIOperationsProgressDialog, OPPROGDLG_DEFAULT)

    
    ' alle Operationen Move, Delete usw. funktionieren
    ' entsprechend gleich.
    
    ' Aufrumen
    Set cIFileOperationProgressSink = Nothing
    Set cIOperationsProgressDialog = Nothing

End Sub

' ----==== Interface IFileOperationProgressSink Events ====----
'
' Wenn das optionale Interface IFileOperationProgressSink verwendet wird,
' dann knnen diverse Events und Parameter hier ausgewertet werden.
'
Private Sub cIFileOperationProgressSink_StartOperations()

    Debug.Print "----==== StartOperations ====----"

End Sub

Private Sub cIFileOperationProgressSink_FinishOperations(ByVal hrResult As Long)

    Debug.Print "----==== FinishOperations ====----"
    Debug.Print "hrResult = " & CStr(hrResult)

End Sub

Private Sub cIFileOperationProgressSink_PreRenameItem(ByVal dwFlags As _
    TRANSFER_SOURCE_FLAGS, ByVal psiItem As Long, ByVal pszNewName As Long)

    ' siehe cIFileOperationProgressSink_PreCopyItem oder
    ' cIFileOperationProgressSink_PostCopyItem

End Sub

Private Sub cIFileOperationProgressSink_PostRenameItem(ByVal dwFlags As _
    TRANSFER_SOURCE_FLAGS, ByVal psiItem As Long, ByVal pszNewName As Long, ByVal _
    hrRename As Long, ByVal psiNewlyCreated As Long)

    ' siehe cIFileOperationProgressSink_PreCopyItem oder
    ' cIFileOperationProgressSink_PostCopyItem

End Sub

Private Sub cIFileOperationProgressSink_PreMoveItem(ByVal dwFlags As _
    TRANSFER_SOURCE_FLAGS, ByVal psiItem As Long, ByVal psiDestinationFolder As _
    Long, ByVal pszNewName As Long)

    ' siehe cIFileOperationProgressSink_PreCopyItem oder
    ' cIFileOperationProgressSink_PostCopyItem

End Sub

Private Sub cIFileOperationProgressSink_PostMoveItem(ByVal dwFlags As _
    TRANSFER_SOURCE_FLAGS, ByVal psiItem As Long, ByVal psiDestinationFolder As _
    Long, ByVal pszNewName As Long, ByVal hrMove As Long, ByVal psiNewlyCreated As _
    Long)

    ' siehe cIFileOperationProgressSink_PreCopyItem oder
    ' cIFileOperationProgressSink_PostCopyItem

End Sub

Private Sub cIFileOperationProgressSink_PreCopyItem(ByVal dwFlags As _
    TRANSFER_SOURCE_FLAGS, ByVal psiItem As Long, ByVal psiDestinationFolder As _
    Long, ByVal pszNewName As Long)

'    Debug.Print "----==== PreCopyItem ====----"
'    Debug.Print "dwFlags = " & CStr(dwFlags)
'    Debug.Print "psiItem = " & ShItemInfo(psiItem)
'    Debug.Print "psiDestinationFolder = " & ShItemInfo(psiDestinationFolder)
'    Debug.Print "pszNewName = " & Ptr2Str(pszNewName)

End Sub

Private Sub cIFileOperationProgressSink_PostCopyItem(ByVal dwFlags As _
    TRANSFER_SOURCE_FLAGS, ByVal psiItem As Long, ByVal psiDestinationFolder As _
    Long, ByVal pszNewName As Long, ByVal hrCopy As Long, ByVal psiNewlyCreated As _
    Long)

'    Debug.Print "----==== PostCopyItem ====----"
'    Debug.Print "dwFlags = " & CStr(dwFlags)
'    Debug.Print "psiItem = " & ShItemInfo(psiItem)
'    Debug.Print "psiDestinationFolder = " & ShItemInfo(psiDestinationFolder)
'    Debug.Print "pszNewName = " & Ptr2Str(pszNewName)
'    Debug.Print "hrCopy = " & CStr(hrCopy)
'    Debug.Print "psiNewlyCreated = " & ShItemInfo(psiNewlyCreated)

End Sub

Private Sub cIFileOperationProgressSink_PreDeleteItem(ByVal dwFlags As _
    TRANSFER_SOURCE_FLAGS, ByVal psiItem As Long)

    ' siehe cIFileOperationProgressSink_PreCopyItem oder
    ' cIFileOperationProgressSink_PostCopyItem

End Sub

Private Sub cIFileOperationProgressSink_PostDeleteItem(ByVal dwFlags As _
    TRANSFER_SOURCE_FLAGS, ByVal psiItem As Long, ByVal hrDelete As Long, ByVal _
    psiNewlyCreated As Long)

    ' siehe cIFileOperationProgressSink_PreCopyItem oder
    ' cIFileOperationProgressSink_PostCopyItem

End Sub

Private Sub cIFileOperationProgressSink_PreNewItem(ByVal dwFlags As _
    TRANSFER_SOURCE_FLAGS, ByVal psiDestinationFolder As Long, ByVal pszNewName As _
    Long)

    ' siehe cIFileOperationProgressSink_PreCopyItem oder
    ' cIFileOperationProgressSink_PostCopyItem

End Sub

Private Sub cIFileOperationProgressSink_PostNewItem(ByVal dwFlags As _
    TRANSFER_SOURCE_FLAGS, ByVal psiDestinationFolder As Long, ByVal pszNewName As _
    Long, ByVal pszTemplateName As Long, ByVal dwFileAttributes As Long, ByVal _
    hrNew As Long, ByVal psiNewItem As Long)

    ' siehe cIFileOperationProgressSink_PreCopyItem oder
    ' cIFileOperationProgressSink_PostCopyItem

End Sub

Private Sub cIFileOperationProgressSink_UpdateProgress(ByVal iWorkTotal As Long, _
    ByVal iWorkSoFar As Long)
    
'    Debug.Print "----==== UpdateProgress ====----"
'    Debug.Print "iWorkTotal = " & CStr(iWorkTotal)
'    Debug.Print "iWorkSoFar = " & CStr(iWorkSoFar)
'
'    Wenn das optionale Interface IOperationsProgressDialog verwendet wird,
'    knnen auch von ProgressDialog diverse Eigenschaften und Werte ausgelesen werden.
'
'    If Not cIOperationsProgressDialog Is Nothing Then
'
'        Debug.Print "ProgressDialog OperationStatus = " & CStr(cIOperationsProgressDialog.GetOperationStatus)
'
'        Dim curElapsed As Currency
'        Dim curRemaining As Currency
'
'        If cIOperationsProgressDialog.GetMilliseconds(curElapsed, curRemaining) = True Then
'
'            Debug.Print "ProgressDialog Time Elapsed = " & ConvertMStoTime(curElapsed)
'            Debug.Print "ProgressDialog Time Remaining = " & ConvertMStoTime(curRemaining)
'
'        End If
'
'    End If

End Sub

Private Sub cIFileOperationProgressSink_ResetTimer()

    Debug.Print "----==== ResetTimer ====----"

End Sub

Private Sub cIFileOperationProgressSink_PauseTimer()

    Debug.Print "----==== PauseTimer ====----"

End Sub

Private Sub cIFileOperationProgressSink_ResumeTimer()

    Debug.Print "----==== ResumeTimer ====----"

End Sub
